/*****************************************************
 *  Bluetooth$B$N;HMQNc(B
 *  $B>o;~%G!<%?<u?.!"<u?.%G!<%?$K1~$8$F=hM}<B9T(B
 * $B!!(BN$B!'?t;z@^$jJV$7(B
 * $B!!(BA$B!'1QJ8;z@^$jJV$7(B
 * $B!!(B1,2$B!'(BLED$B#1%*%s%*%U(B
 * $B!!(B3,4$B!'(BLED$B#2%*%s%*%U(B
 *   S1$B!'2!$7$F$$$k4V(BASCII$B%3!<%IAw?.7+$jJV$7(B
 *   S2$B!'2!$7$F$$$k4V%a%C%;!<%8Aw?.7+$jJV$7(B
 *   $B%U%!%$%kL>!'(BBT_Tiny.c
******************************************************/
#include <htc.h>
/***** $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B *********/
// CONFIG1
#pragma config FOSC = INTOSC    // $BFbB"H/?6!!%/%m%C%/%T%s(BI/O
#pragma config WDTE = OFF       // WDT$B6X;_(B
#pragma config PWRTE = ON       // PWRT$BM-8z(B
#pragma config MCLRE = ON       // MCLR$BM-8z(B
#pragma config CP = OFF         // $B%W%m%F%/%H$J$7(B
#pragma config CPD = OFF        // $B%G!<%?%W%m%F%/%H$J$7(B
#pragma config BOREN = ON       // BOR$BM-8z(B
#pragma config CLKOUTEN = ON    // $B%/%m%C%/=PNO$"$j(B
#pragma config IESO = OFF       // $B%/%m%C%/@Z$jBX$($J$7(B
#pragma config FCMEN = OFF      // $B%/%m%C%/%b%K%?L58z(B

// CONFIG2
#pragma config WRT = OFF        // $B%;%k%U%i%$%HL58z(B
#pragma config PLLEN = ON       // PLL$BM-8z(B
#pragma config STVREN = OFF     // $B%9%?%C%/4F;k$J$7(B
#pragma config BORV = LO        // BOR$BDcEE05(B
#pragma config LVP = OFF        // LVP$B$J$7(B

/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
#define  Max            256
unsigned char data, rcv, ascii;
unsigned char Buf[Max];
int Index, i;
unsigned char Msg[] = "\r\n***__Switch2__Pressed__***";
/* $B4X?t%W%m%H%?%$%T%s%0(B */
void Send(unsigned char Data);
void Delayms( unsigned int t);

/******** $B%a%$%s4X?t(B  ************/
void main(void) {
    /** $B%/%m%C%/@_Dj(B **/
    OSCCON = 0xF0;                      // $BFbB"(B8MHz$B!!(BPLL On 32MHz
    /* $BF~=PNO%]!<%H$N@_Dj(B */
    ANSELA = 0x02;                      // RA1$B$N$_%"%J%m%0F~NO(B
    ANSELB = 0;
    TRISA = 0x22;
    TRISB = 0xFF;                       // $BA4F~NO(B
    /* BT$B%b%8%e!<%k=i4|2=(B */
    PORTAbits.RA4 = 0;                  // RTS Off
    PORTAbits.RA0 = 0;                  // BT$B%b%8%e!<%k%j%;%C%H(B
    Delayms(200);
    PORTAbits.RA0 = 1;     
    WPUB = 0x18;                        // RB3,4 pullup
    OPTION_REGbits.nWPUEN = 0;          // Pullup Enable
    /* USART$B$N=i4|@_Dj(B */
    TXSTA = 0x24;                       // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=1
    RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                       // BAUDCON$B!!(B16bit
    SPBRG = 68;                         // SPBRG,$BDL?.B.EY@_Dj(B(115kbps)
    /* $BJQ?t=i4|2=(B */
    Index = 0;
    ascii = 0x20;
    /* $B3d$j9~$_5v2D(B */
    PIR1bits.RCIF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.RCIE = 1;                  // USART$B<u?.3d$j9~$_5v2D(B
    INTCONbits.PEIE = 1;                // $B<~JU5v2D(B
    INTCONbits.GIE = 1;                 // $B%0%m!<%P%k5v2D(B

    /************ $B%a%$%s%k!<%W(B  ********************/
    while (1) {
        /** $B<u?.%G!<%?=hM}(B **/
        if(Index > 0){                          // $B<u?.%P%C%U%!$,6u$G$J$$>l9g(B
            i = 0;                              // $B%P%C%U%!%]%$%s%?=i4|2=(B
            while(i < Index){                   // $B<u?.%P%C%U%!6u$^$G7+$jJV$7(B
                switch(Buf[i++]){               // $B<u?.%G!<%?$GJ,4t(B
                    case 'A':                   // $BJ8;z(BA$B$+(Ba$B$N>l9g(B
                    case 'a':
                        Send(0x0D);             // $B1QJ8;zAw?.(B
                        Send(0x0A);                        
                        for(data = 'A'; data <= 'Z'; data++)
                            Send(data);
                        break;
                    case 'N':                   // $BJ8;z(BN$B$+(Bn$B$N>l9g(B
                    case 'n':
                        Send(0x0D);
                        Send(0x0A);             // $B?t;zAw?.(B
                        for(data = '0'; data <= '9'; data++)
                            Send(data);
                        break;
                    case '1':                   // $BJ8;z(B1$B$N>l9g(B
                        PORTAbits.RA2 = 1;      // LED$B#1%*%s(B
                        break;
                    case '2':                   // $BJ8;z(B2$B$N>l9g(B
                        PORTAbits.RA2 = 0;      // LED1$B%*%U(B
                        break;
                    case '3':                   // $BJ8;z(B3$B$N>l9g(B
                        PORTAbits.RA3 = 1;      // LED2$B%*%s(B
                        break;
                    case '4':                   // $BJ8;z(B4$B$N>l9g(B
                        PORTAbits.RA3 = 0;      // LED2$B%*%U(B
                        break;
                    default: break;
                }
            }
            Index = 0;                              // $B%P%C%U%!$r6u$H$9$k(B
        }
        /** $B%9%$%C%A$N=hM}(B **/
        if(RB3 == 0){                               // S1$B%*%s$N>l9g(B
            Send(0x0D);                             // $B2~9TAw?.(B
            Send(0x0A);            
            for(ascii = 0x40; ascii<0x80; ascii++)  // ASCII$BJ8;zAw?.(B
                Send(ascii);                        // 1$BJ8;zAw?.(B
           Delayms(100);                            // 100msec$BBT$A(B
        }
        if(RB4 == 0){                               // S2$B%*%s$N>l9g(B
            i = 0;                                  // $B%P%C%U%!%]%$%s%?=i4|2=(B
            while(Msg[i] != 0)                      // $B%a%C%;!<%8:G8e$^$G7+$jJV$7(B
                Send(Msg[i++]);                     // 1$BJ8;zAw?.(B
            Delayms(50);                            // 50msec$BBT$A(B
        }
    }
}
/*************************************
* $B3d$j9~$_=hM}4X?t(B
* $B!!<u?.3d$j9~$_(B
*************************************/
void interrupt isr(void){
    if(PIR1bits.RCIF){                          // $B<u?.3d$j9~$_$+!)(B
        PIR1bits.RCIF = 0;                      // $B<u?.3d$j9~$_%U%i%0%/%j%"(B
        if((RCSTAbits.OERR) || (RCSTAbits.FERR)){   // $B%(%i!<H/@8$7$?>l9g(B
            RCSTA = 0;                          // USART$BL58z2=(B
            RCSTA = 0x90;                       // USART$B:FM-8z2=(B
        }
        else{                                   // $B@5>o<u?.$N>l9g(B
            if(Index < Max){                    // $B%P%C%U%!1[$($F$J$$>l9g(B
                Buf[Index++] = RCREG;           // $B<u?.%G!<%?$r%;%C%H(B
            }
            else
                rcv = RCREG;                    // $B%P%C%U%!1[$($?$i<N$F$k(B
        }
    }
}

/********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!TXSTAbits.TRMT);                     // $BAw?.%l%G%#!<BT$A(B
    TXREG = Data;                               // $BAw?.<B9T(B
}
/***********************************************
* $B%?%$%^(B2$B$K$h$k(B1msec$BC10L$NCY1d4X?t(B Tcy=8MHz
***********************************************/
void Delayms( unsigned int t){
    PIR1bits.TMR2IF = 0;                // $B3d$j9~$_%U%i%0%/%j%"(B
    PR2 = 125;                          // 1msec$B@_Dj(B  125
    T2CON = 0x07;                       // $B%?%$%^(B2$B%9%?!<%H!!(B1/64
    while (t--) {                       // $B7+$jJV$72s?t(B
        while (!PIR1bits.TMR2IF);       // 1msec$BBT$A(B
        PIR1bits.TMR2IF = 0;            // $B3d$j9~$_%U%i%0%/%j%"(B
    }
}
